# generated by datamodel-codegen:
#   filename:  experts-portal-money.json

from __future__ import annotations

from typing import Annotated, Literal
from uuid import UUID

from pydantic import BaseModel, ConfigDict, Field

from ...repository.config import (
    MoneyConfigAnnotationSettings,
    MoneyConfigCommonSettings,
    MoneyConfigPostAcceptanceSettings,
    MoneyConfigSnippetSettings,
    MoneyConfigStatusWorkflowSettings,
)


class MoneyConfigIdView(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    config_id: UUID | None = None
    version_id: UUID | None = None


class MoneyConfigView(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    config_id: UUID | None = None
    version_id: UUID | None = None
    name: str | None = None
    currency: Literal['USD', 'BU'] | None = None
    created_at: Annotated[str | None, Field(examples=['2024-08-12T12:41:07.629'])] = None
    created_by_account_id: str | None = None
    requester_id: str | None = None
    snippet_settings: MoneyConfigSnippetSettings | None = None
    common_settings: MoneyConfigCommonSettings | None = None
    specific_settings: (
        MoneyConfigAnnotationSettings | MoneyConfigPostAcceptanceSettings | MoneyConfigStatusWorkflowSettings | None
    ) = None
