# generated by datamodel-codegen:
#   filename:  experts-portal-money.json

from __future__ import annotations

from typing import Annotated, Literal

from pydantic import BaseModel, ConfigDict, Field

from ..model.withdraw import PageRequestObject


class CreateTransactionRequestForm(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    paymentSystem: str
    amount: float


class CalculateAmountForm(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    payment_system: Literal['FLUTTERWAVE', 'ONTOP', 'PAPARA', 'PAYONEER', 'SOLAR', 'FILE']
    amount: float


class AssignPaymentProviderRequestForm(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    payment_provider: str
    worker_id: str
    external_key: str


class PatchAccountForm(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    current: bool | None = None
    use_for_uniqueness_check: bool | None = None


class PatchPaymentSystemForm(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    is_autopayment_enabled: bool | None = None


class TransactionPaginationConfigForm(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    page: Annotated[int | None, Field(ge=0, le=100)] = None
    size: Annotated[int | None, Field(ge=1, le=100)] = None
    direction: Literal['ASC', 'DESC'] | None = None
    properties: str | None = None
    pageable: PageRequestObject | None = None
