# generated by datamodel-codegen:
#   filename:  experts-portal-qualification.json

from __future__ import annotations

from typing import Annotated, Literal, Sequence
from uuid import UUID

from pydantic import BaseModel, ConfigDict, Field

from ...domain import UserQualificationResult


class UserQualificationForm(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    account_id: str | None = None
    qualification_id: UUID | None = None
    result: UserQualificationResult | None = None


class UserQualificationView(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    id: UUID | None = None
    title: str | None = None
    account_id: str | None = None
    qualification_id: UUID | None = None
    result: UserQualificationResult | None = None
    acquired_at: Annotated[str | None, Field(examples=['2024-08-12T12:41:07.629'])] = None
    allowed_actions: Sequence[str] | None = None


class QualificationFormUI(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    title: str | None = None
    description: str | None = None
    tenant_id: str | None = None
    status: Literal['ACTIVE', 'ARCHIVED'] | None = None
    category: Literal['ROLE', 'LANGUAGE', 'SPECIALIZATION', 'PROJECT', 'VERIFICATION'] | None = None
    performer_type: Literal['TOLOKER', 'EXPERT'] | None = None


class QualificationViewUI(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    id: UUID | None = None
    title: str | None = None
    description: str | None = None
    tenant_id: str | None = None
    status: Literal['ACTIVE', 'ARCHIVED'] | None = None
    category: Literal['ROLE', 'LANGUAGE', 'SPECIALIZATION', 'PROJECT', 'VERIFICATION'] | None = None
    created_at: Annotated[str | None, Field(examples=['2024-08-12T12:41:07.629'])] = None
    updated_at: Annotated[str | None, Field(examples=['2024-08-12T12:41:07.629'])] = None
    performer_type: Literal['TOLOKER', 'EXPERT'] | None = None
    allowed_actions: Sequence[str] | None = None


class CloseInformerRequest(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    pipeline_id: str | None = None
    step_id: str | None = None


class GetQualificationListQueryParams(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    id: UUID | None = None
    id_gte: str | None = None
    id_lte: str | None = None
    status: Sequence[Literal['ACTIVE', 'ARCHIVED']] | None = None
    category: Sequence[Literal['ROLE', 'LANGUAGE', 'SPECIALIZATION', 'PROJECT', 'VERIFICATION']] | None = None
    performer_type: Sequence[Literal['TOLOKER', 'EXPERT']] | None = None
    search: str | None = None


class QualificationSearchView(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    id: UUID | None = None
    title: str | None = None
    description: str | None = None
    tenant_id: str | None = None
    status: Literal['ACTIVE', 'ARCHIVED'] | None = None
    category: Literal['ROLE', 'LANGUAGE', 'SPECIALIZATION', 'PROJECT', 'VERIFICATION'] | None = None
    created_at: Annotated[str | None, Field(examples=['2024-08-12T12:41:07.629'])] = None
    updated_at: Annotated[str | None, Field(examples=['2024-08-12T12:41:07.629'])] = None
    performer_type: Literal['TOLOKER', 'EXPERT'] | None = None
    performers_count: int | None = None
